// here we should have includes for all used types
// from all packages.
#include "DeployTypes.hpp"

Component* deploy(int argc, char **argv);
bool isSerializeEnabled();
void serialize(char **buf, size_t *len);
void deserialize(const char *buf, size_t len);

namespace staticallocated{

    // data param for Comp__ROOT./
    

    AtomIPort__controllerB__silent iport__ROOT__brake__tick("tick");

    AtomIPort__controllerB__floatPort iport__ROOT__brake__brake("brake");

    AtomIPort__controllerB__floatPort iport__ROOT__brake__changeSpeed("changeSpeed");

    AtomEPort__controllerB__silent port__ROOT__brake__tick("tick", false);

    AtomEPort__controllerB__floatPort port__ROOT__brake__changeSpeed("changeSpeed", false);

    // static init for Atom: Comp__ROOT__brake
    

    AT__controllerB__Brake Comp__ROOT__brake(
     "brake"
     , iport__ROOT__brake__tick, iport__ROOT__brake__brake, iport__ROOT__brake__changeSpeed
     
     , port__ROOT__brake__tick, port__ROOT__brake__changeSpeed
     
     
    );


    AtomIPort__controllerB__silent iport__ROOT__throttle__tick("tick");

    AtomIPort__controllerB__floatPort iport__ROOT__throttle__throttle("throttle");

    AtomIPort__controllerB__floatPort iport__ROOT__throttle__changeSpeed("changeSpeed");

    AtomEPort__controllerB__silent port__ROOT__throttle__tick("tick", false);

    AtomEPort__controllerB__floatPort port__ROOT__throttle__changeSpeed("changeSpeed", false);

    // static init for Atom: Comp__ROOT__throttle
    

    AT__controllerB__Throttle Comp__ROOT__throttle(
     "throttle"
     , iport__ROOT__throttle__tick, iport__ROOT__throttle__throttle, iport__ROOT__throttle__changeSpeed
     
     , port__ROOT__throttle__tick, port__ROOT__throttle__changeSpeed
     
     
    );


    AtomIPort__controllerB__silent iport__ROOT__speedSensor__tick("tick");

    AtomIPort__controllerB__floatPort iport__ROOT__speedSensor__changeSpeed("changeSpeed");

    AtomEPort__controllerB__silent port__ROOT__speedSensor__tick("tick", false);

    AtomEPort__controllerB__floatPort port__ROOT__speedSensor__changeSpeed("changeSpeed", false);

    // static init for Atom: Comp__ROOT__speedSensor
    

    AT__controllerB__SpeedSensor Comp__ROOT__speedSensor(
     "speedSensor"
     , iport__ROOT__speedSensor__tick, iport__ROOT__speedSensor__changeSpeed
     
     , port__ROOT__speedSensor__tick, port__ROOT__speedSensor__changeSpeed
     
     
    );


    QPR__controllerB__floatPort ref__ROOT__throttleAction__p1(port__ROOT__throttle__changeSpeed, false);

    QPR__controllerB__floatPort ref__ROOT__throttleAction__p2(port__ROOT__speedSensor__changeSpeed, false);

    ConnT__controllerB__rendezVous Conn__ROOT__throttleAction(
        "throttleAction",
        ref__ROOT__throttleAction__p1, ref__ROOT__throttleAction__p2
        
        );

    QPR__controllerB__floatPort ref__ROOT__brakeAction__p1(port__ROOT__brake__changeSpeed, false);

    QPR__controllerB__floatPort ref__ROOT__brakeAction__p2(port__ROOT__speedSensor__changeSpeed, false);

    ConnT__controllerB__rendezVous Conn__ROOT__brakeAction(
        "brakeAction",
        ref__ROOT__brakeAction__p1, ref__ROOT__brakeAction__p2
        
        );

    QPR__controllerB__silent ref__ROOT__noChange__p1(port__ROOT__brake__tick, false);

    QPR__controllerB__silent ref__ROOT__noChange__p2(port__ROOT__throttle__tick, false);

    QPR__controllerB__silent ref__ROOT__noChange__p3(port__ROOT__speedSensor__tick, false);

    ConnT__controllerB__noChange Conn__ROOT__noChange(
        "noChange",
        ref__ROOT__noChange__p1, ref__ROOT__noChange__p2, ref__ROOT__noChange__p3
        
        );

    // static init for Compound: Comp__ROOT

    CT__controllerB__Compound Comp__ROOT(
      "ROOT"
     , Comp__ROOT__brake, Comp__ROOT__throttle, Comp__ROOT__speedSensor
     
     , Conn__ROOT__throttleAction, Conn__ROOT__brakeAction, Conn__ROOT__noChange
     
     
     
     
    );


// End of namespace.
};
