#ifndef CONTROLLERB_AT____CONTROLLERB____THROTTLE_HPP_
#define CONTROLLERB_AT____CONTROLLERB____THROTTLE_HPP_

// /home/siemens/bip/examples/SpeedControlModule/modelDetection/wp42/controllerB/controllerB.bip:36:1
// include package "master" header
#include <controllerB.hpp>

#include <Atom.hpp>

// User include given in @cpp annotation
#include <utilities.hpp>

#include <controllerB/AtomIPort__controllerB__silent.hpp>
#include <controllerB/AtomIPort__controllerB__floatPort.hpp>


#include <controllerB/AtomEPort__controllerB__silent.hpp>
#include <controllerB/AtomEPort__controllerB__floatPort.hpp>

#include <controllerB/PV__controllerB__floatPort.hpp>
#include <controllerB/PV__controllerB__silent.hpp>



class AT__controllerB__Throttle : public Atom {
private:
   // internal ports & associated port values
    AtomIPort__controllerB__silent &_iport_decl__tick;
    PV__controllerB__silent _iport_decl_pv__tick;
    AtomIPort__controllerB__floatPort &_iport_decl__throttle;
    PV__controllerB__floatPort _iport_decl_pv__throttle;
    AtomIPort__controllerB__floatPort &_iport_decl__changeSpeed;
    PV__controllerB__floatPort _iport_decl_pv__changeSpeed;

    // exported ports
    AtomEPort__controllerB__silent &_eport_decl__tick;
    AtomEPort__controllerB__floatPort &_eport_decl__changeSpeed;
public:
    AT__controllerB__Throttle(const string &name , AtomIPort__controllerB__silent &_iport_decl__tick, AtomIPort__controllerB__floatPort &_iport_decl__throttle, AtomIPort__controllerB__floatPort &_iport_decl__changeSpeed
                             
                             , AtomEPort__controllerB__silent &_eport_decl__tick, AtomEPort__controllerB__floatPort &_eport_decl__changeSpeed
                             
                             );
    virtual ~AT__controllerB__Throttle();

    virtual BipError& execute(PortValue &portValue);
    virtual BipError& execute(AtomExternalPort &portValue);
    virtual BipError& initialize();
    virtual string toString() const;

protected:
    BipError& update();

    BipError& executeInternalTransitions();
    BipError& checkInvariants();

    const static size_t bvector_size = 2/(8*sizeof(int))+((2%(8*sizeof(int))) > 0 ? 1 : 0);
    int __statesbv[ bvector_size ];

    // component data declarations
    double _id__deltaSpeed;

    // enabledness of transitions
    bool _transguard__1;
    bool _transguard__2;
    bool _transguard__3;

    // guards of priorities
    bool _prioguard__throttleCommand;

    // enabledness of priorities
    bool _prioenabled__throttleCommand;

    // enabledness of priority paths
    bool _priopathenabled__1;

    // index of the latest executed transition
    int __previous;

    bool atIdle() const;
    bool toIdle();
    bool fromIdle();
    bool atAction() const;
    bool toAction();
    bool fromAction();
};

#endif // CONTROLLERB_AT____CONTROLLERB____THROTTLE_HPP_
