#ifndef INCLUDE_CONTROLLERB_ATOMEPORT____CONTROLLERB____FLOATPORT_HPP_
#define INCLUDE_CONTROLLERB_ATOMEPORT____CONTROLLERB____FLOATPORT_HPP_

#include <AtomExportPort.hpp>
#include <controllerB/AtomIPort__controllerB__floatPort.hpp>

#include <controllerB/PT__controllerB__floatPort.hpp>

class AtomEPort__controllerB__floatPort :
    public virtual Port,
    public AtomExportPort,
    public PT__controllerB__floatPort {
public:
    AtomEPort__controllerB__floatPort(const string &name, bool hasEarlyUpdate);
    virtual ~AtomEPort__controllerB__floatPort();
    virtual void addInternalPort(AtomIPort__controllerB__floatPort &p);

    virtual vector<PortValue *> &portValues();
    virtual const vector<PortValue *> &portValues() const;
    virtual bool hasPortValues() const;
    virtual void addPortValue(PortValue &port);
    virtual void clearPortValues();

    virtual bool isReset() const;
    void setIsReset(bool b);

protected:
// Getting messy to store actual type and return more abstract one (thanks to vector template...)
//    vector<PV__controllerB__floatPort *> mPortValues;
    vector<PortValue *> mPortValues;
    bool mIsReset;
}; 


inline
void AtomEPort__controllerB__floatPort::addInternalPort(AtomIPort__controllerB__floatPort &p) {
    AtomExportPort::addInternalPort(p);
}

inline
vector<PortValue *> &AtomEPort__controllerB__floatPort::portValues() {
    return mPortValues;
}

inline
const vector<PortValue *> &AtomEPort__controllerB__floatPort::portValues() const {
    return mPortValues;
}

inline
bool AtomEPort__controllerB__floatPort::hasPortValues() const {
    return !mPortValues.empty();
}

inline
void AtomEPort__controllerB__floatPort::addPortValue(PortValue &port) {
    mPortValues.push_back(&port);
}

inline
void AtomEPort__controllerB__floatPort::clearPortValues() {
    mPortValues.clear();
}

inline
bool AtomEPort__controllerB__floatPort::isReset() const {
    return mIsReset;
}

inline
void AtomEPort__controllerB__floatPort::setIsReset(bool b) {
    mIsReset = b;
}
#endif // INCLUDE_CONTROLLERB_ATOMEPORT____CONTROLLERB____FLOATPORT_HPP_
