#ifndef INCLUDE_CONTROLLERB_ATOMIPORT____CONTROLLERB____FLOATPORT_HPP_
#define INCLUDE_CONTROLLERB_ATOMIPORT____CONTROLLERB____FLOATPORT_HPP_

#include <AtomInternalPort.hpp>

#include <controllerB/PT__controllerB__floatPort.hpp>
#include <controllerB/PV__controllerB__floatPort.hpp>

class AtomIPort__controllerB__floatPort : public AtomInternalPort {
public:
    AtomIPort__controllerB__floatPort(const string &name);
    virtual ~AtomIPort__controllerB__floatPort();

    PortValue &portValue() const;
    bool hasPortValue() const;
    void setPortValue(PortValue &portValue);
    void clearPortValue();

    bool isEnabled() const;
    void setIsEnabled(bool b);
    bool isDisabledByPriorities() const;
    void setIsDisabledByPriorities(bool b);

protected:
    PV__controllerB__floatPort *mPortValue;

private:
    bool mIsEnabled;
    bool mIsDisabledByPriorities;
}; 

inline
PortValue &AtomIPort__controllerB__floatPort::portValue() const {
    return *mPortValue;
}

inline
bool AtomIPort__controllerB__floatPort::hasPortValue() const {
    return mPortValue != NULL;
}

inline
void AtomIPort__controllerB__floatPort::setPortValue(PortValue &portValue) {
    assert(dynamic_cast<PV__controllerB__floatPort *>(&portValue) != NULL);
    mPortValue = static_cast<PV__controllerB__floatPort *> (&portValue);
}
inline
void AtomIPort__controllerB__floatPort::clearPortValue() {
    mPortValue = NULL;
}

inline
bool AtomIPort__controllerB__floatPort::isEnabled() const {
    return mIsEnabled;
}

inline
void AtomIPort__controllerB__floatPort::setIsEnabled(bool b) {
    mIsEnabled = b;
}

inline
bool AtomIPort__controllerB__floatPort::isDisabledByPriorities() const {
    return mIsDisabledByPriorities;
}

inline
void AtomIPort__controllerB__floatPort::setIsDisabledByPriorities(bool b) {
    mIsDisabledByPriorities = b;
}

#endif // INCLUDE_CONTROLLERB_ATOMIPORT____CONTROLLERB____FLOATPORT_HPP_
