#ifndef INCLUDE_CONTROLLERB_ATOMIPORT____CONTROLLERB____SILENT_HPP_
#define INCLUDE_CONTROLLERB_ATOMIPORT____CONTROLLERB____SILENT_HPP_

#include <AtomInternalPort.hpp>

#include <controllerB/PT__controllerB__silent.hpp>
#include <controllerB/PV__controllerB__silent.hpp>

class AtomIPort__controllerB__silent : public AtomInternalPort {
public:
    AtomIPort__controllerB__silent(const string &name);
    virtual ~AtomIPort__controllerB__silent();

    PortValue &portValue() const;
    bool hasPortValue() const;
    void setPortValue(PortValue &portValue);
    void clearPortValue();

    bool isEnabled() const;
    void setIsEnabled(bool b);
    bool isDisabledByPriorities() const;
    void setIsDisabledByPriorities(bool b);

protected:
    PV__controllerB__silent *mPortValue;

private:
    bool mIsEnabled;
    bool mIsDisabledByPriorities;
}; 

inline
PortValue &AtomIPort__controllerB__silent::portValue() const {
    return *mPortValue;
}

inline
bool AtomIPort__controllerB__silent::hasPortValue() const {
    return mPortValue != NULL;
}

inline
void AtomIPort__controllerB__silent::setPortValue(PortValue &portValue) {
    assert(dynamic_cast<PV__controllerB__silent *>(&portValue) != NULL);
    mPortValue = static_cast<PV__controllerB__silent *> (&portValue);
}
inline
void AtomIPort__controllerB__silent::clearPortValue() {
    mPortValue = NULL;
}

inline
bool AtomIPort__controllerB__silent::isEnabled() const {
    return mIsEnabled;
}

inline
void AtomIPort__controllerB__silent::setIsEnabled(bool b) {
    mIsEnabled = b;
}

inline
bool AtomIPort__controllerB__silent::isDisabledByPriorities() const {
    return mIsDisabledByPriorities;
}

inline
void AtomIPort__controllerB__silent::setIsDisabledByPriorities(bool b) {
    mIsDisabledByPriorities = b;
}

#endif // INCLUDE_CONTROLLERB_ATOMIPORT____CONTROLLERB____SILENT_HPP_
