#ifndef CONTROLLERB_CONNT____CONTROLLERB____NOCHANGE_HPP_
#define CONTROLLERB_CONNT____CONTROLLERB____NOCHANGE_HPP_

// /home/siemens/bip/examples/SpeedControlModule/modelDetection/wp42/controllerB/controllerB.bip:17:1
// include package "master" header
#include <controllerB.hpp>

#include <Connector.hpp>
#include <Interaction.hpp>
#include <PortValue.hpp>

#if __cplusplus >= 201103L
#include <atomic>
#endif

// User include given in @cpp annotation
#include <utilities.hpp>

#include <controllerB/QPR__controllerB__silent.hpp>
#include <controllerB/InterV__controllerB__noChange.hpp>

class ConnT__controllerB__noChange : public Connector {
public:
    ConnT__controllerB__noChange(const string &name, QPR__controllerB__silent &p1, QPR__controllerB__silent &p2, QPR__controllerB__silent &p3);
    virtual ~ConnT__controllerB__noChange();

    virtual PortValue &up(const InteractionValue &interactionValue) const;
    virtual void down(InteractionValue &interactionValue) const;
    virtual void down(InteractionValue &interactionValue, PortValue &portValue) const;

    virtual Interaction &createInteraction() const;
    virtual Interaction &createInteraction(const vector<Port *> &ports) const;
    virtual void releaseInteraction(Interaction &interaction) const;

    virtual InteractionValue &createInteractionValue(const Interaction &interactionValue, const vector<PortValue *> &values) const;
    virtual void releaseInteractionValue(InteractionValue &interactionValue) const;

    virtual bool guard(const InteractionValue &interactionValue) const;
    virtual const vector<Interaction *> &interactions() const;
    virtual bool canUpOnlyMaximalInteractions() const {
        return false;
    }

private:
    QPR__controllerB__silent &p1;
    QPR__controllerB__silent &p2;
    QPR__controllerB__silent &p3;




    mutable vector<Interaction *> definedInteractions;
};
#endif // CONTROLLERB_CONNT____CONTROLLERB____NOCHANGE_HPP_
