// /home/siemens/bip/examples/SpeedControlModule/modelDetection/wp42/controllerB/controllerB.bip:17:1

#include <controllerB/ConnT__controllerB__noChange.hpp>

#include <controllerB/PV__controllerB__silent.hpp>


static inline PortValue * getPortValue(const QuotedPortReference & qpr, const InteractionValue &civ){
    Port &p = qpr.port();
    vector<Port *>::size_type idx = 0;
    for (vector<Port *>::const_iterator i = civ.ports().begin();
         i != civ.ports().end();
         i++, idx++){
        if (&p == *i) break;
    }
    assert (idx < civ.ports().size()); // means we couldn't find corresponding port value 
    return civ.portValues()[idx];
}

static inline PV__controllerB__silent * get_p1(const QPR__controllerB__silent & qpr, const InterV__controllerB__noChange &civ){
  return dynamic_cast<PV__controllerB__silent *>(getPortValue(qpr, civ));
}
static inline PV__controllerB__silent * get_p2(const QPR__controllerB__silent & qpr, const InterV__controllerB__noChange &civ){
  return dynamic_cast<PV__controllerB__silent *>(getPortValue(qpr, civ));
}
static inline PV__controllerB__silent * get_p3(const QPR__controllerB__silent & qpr, const InterV__controllerB__noChange &civ){
  return dynamic_cast<PV__controllerB__silent *>(getPortValue(qpr, civ));
}


ConnT__controllerB__noChange::ConnT__controllerB__noChange(const string &name, QPR__controllerB__silent &p1, QPR__controllerB__silent &p2, QPR__controllerB__silent &p3) : Connector(name), p1(p1), p2(p2), p3(p3) {
    this->addPort(p1);
    this->addPort(p2);
    this->addPort(p3);
}

ConnT__controllerB__noChange::~ConnT__controllerB__noChange() {
    for (vector<Interaction *>::const_iterator interactionIt = definedInteractions.begin() ;
         interactionIt != definedInteractions.end() ;
         ++interactionIt) {
        delete *interactionIt;
    }
    definedInteractions.clear();
}

PortValue &ConnT__controllerB__noChange::up(const InteractionValue &interactionValue) const {
    // THIS SHOULD *NEVER* HAPPEN.
    assert(false);

    // to avoid warnings
    PortValue *pv = NULL;

    return *pv;
}

void ConnT__controllerB__noChange::down(InteractionValue &interactionValue) const {
    
}

void ConnT__controllerB__noChange::down(InteractionValue &interactionValue, PortValue &portValue) const {
    // You should *never* reach this. Calling this method denotes an error in
    // scheduling (the down(interactionvalue) should have been used
    assert(false);
}

Interaction &ConnT__controllerB__noChange::createInteraction() const{
    Inter__controllerB__noChange *ret = NULL;

    ret = new Inter__controllerB__noChange(*this);

    return *ret;
}

Interaction &ConnT__controllerB__noChange::createInteraction(const vector<Port *> &ports) const{
  Inter__controllerB__noChange *ret = NULL;

    ret = new Inter__controllerB__noChange(*this, ports);

    return *ret;
}

InteractionValue &ConnT__controllerB__noChange::createInteractionValue(const Interaction &interaction, const vector<PortValue *> &values) const {
    InterV__controllerB__noChange *ret = NULL;

    ret = new InterV__controllerB__noChange(*this, interaction, values);

    return *ret;
}

void ConnT__controllerB__noChange::releaseInteraction(Interaction &interaction) const {
    delete &interaction;
}

void ConnT__controllerB__noChange::releaseInteractionValue(InteractionValue &interactionValue) const {
    delete &interactionValue;
}

bool ConnT__controllerB__noChange::guard(const InteractionValue &interactionValue) const {


    // default to true. May not be the wisest choice.
    return true;
}

const vector<Interaction*>& ConnT__controllerB__noChange::interactions() const {
  if (definedInteractions.empty()) {
    definedInteractions.push_back(new Inter__controllerB__noChange(*this, true, true, true));
  }

  // check that the number of defined interactions is correct
  assert(definedInteractions.size() == 1);

  return definedInteractions;
}
