// /home/siemens/bip/examples/SpeedControlModule/modelDetection/wp42/controllerB/controllerB.bip:12:1

#include <controllerB/ConnT__controllerB__rendezVous.hpp>

#include <controllerB/PV__controllerB__floatPort.hpp>


static inline PortValue * getPortValue(const QuotedPortReference & qpr, const InteractionValue &civ){
    Port &p = qpr.port();
    vector<Port *>::size_type idx = 0;
    for (vector<Port *>::const_iterator i = civ.ports().begin();
         i != civ.ports().end();
         i++, idx++){
        if (&p == *i) break;
    }
    assert (idx < civ.ports().size()); // means we couldn't find corresponding port value 
    return civ.portValues()[idx];
}

static inline PV__controllerB__floatPort * get_p1(const QPR__controllerB__floatPort & qpr, const InterV__controllerB__rendezVous &civ){
  return dynamic_cast<PV__controllerB__floatPort *>(getPortValue(qpr, civ));
}
static inline PV__controllerB__floatPort * get_p2(const QPR__controllerB__floatPort & qpr, const InterV__controllerB__rendezVous &civ){
  return dynamic_cast<PV__controllerB__floatPort *>(getPortValue(qpr, civ));
}


ConnT__controllerB__rendezVous::ConnT__controllerB__rendezVous(const string &name, QPR__controllerB__floatPort &p1, QPR__controllerB__floatPort &p2) : Connector(name), p1(p1), p2(p2) {
    this->addPort(p1);
    this->addPort(p2);

    // Interactions
    _i__p1_p2 = new Inter__controllerB__rendezVous(*this, true, true);
}

ConnT__controllerB__rendezVous::~ConnT__controllerB__rendezVous() {

    // Interactions
    delete _i__p1_p2;
    for (vector<Interaction *>::const_iterator interactionIt = definedInteractions.begin() ;
         interactionIt != definedInteractions.end() ;
         ++interactionIt) {
        delete *interactionIt;
    }
    definedInteractions.clear();
}

PortValue &ConnT__controllerB__rendezVous::up(const InteractionValue &interactionValue) const {
    // THIS SHOULD *NEVER* HAPPEN.
    assert(false);

    // to avoid warnings
    PortValue *pv = NULL;

    return *pv;
}

void ConnT__controllerB__rendezVous::down(InteractionValue &interactionValue) const {
    assert(dynamic_cast<const InterV__controllerB__rendezVous *>(&interactionValue) != NULL);
    const Inter__controllerB__rendezVous *c_interaction __attribute__((unused)) = static_cast<const Inter__controllerB__rendezVous *>(&(interactionValue.interaction()));
    const InterV__controllerB__rendezVous *c_interaction_v __attribute__((unused)) = static_cast<const InterV__controllerB__rendezVous *>(&interactionValue);
    if(*c_interaction == *_i__p1_p2) {
    // /home/siemens/bip/examples/SpeedControlModule/modelDetection/wp42/controllerB/controllerB.bip:14:22
        get_p2(p2, *c_interaction_v)->set_d(get_p1(p1, *c_interaction_v)->get_d());
    }
}

void ConnT__controllerB__rendezVous::down(InteractionValue &interactionValue, PortValue &portValue) const {
    // You should *never* reach this. Calling this method denotes an error in
    // scheduling (the down(interactionvalue) should have been used
    assert(false);
}

Interaction &ConnT__controllerB__rendezVous::createInteraction() const{
    Inter__controllerB__rendezVous *ret = NULL;

    ret = new Inter__controllerB__rendezVous(*this);

    return *ret;
}

Interaction &ConnT__controllerB__rendezVous::createInteraction(const vector<Port *> &ports) const{
  Inter__controllerB__rendezVous *ret = NULL;

    ret = new Inter__controllerB__rendezVous(*this, ports);

    return *ret;
}

InteractionValue &ConnT__controllerB__rendezVous::createInteractionValue(const Interaction &interaction, const vector<PortValue *> &values) const {
    InterV__controllerB__rendezVous *ret = NULL;

    ret = new InterV__controllerB__rendezVous(*this, interaction, values);

    return *ret;
}

void ConnT__controllerB__rendezVous::releaseInteraction(Interaction &interaction) const {
    delete &interaction;
}

void ConnT__controllerB__rendezVous::releaseInteractionValue(InteractionValue &interactionValue) const {
    delete &interactionValue;
}

bool ConnT__controllerB__rendezVous::guard(const InteractionValue &interactionValue) const {
    assert(dynamic_cast<const InterV__controllerB__rendezVous *>(&interactionValue) != NULL);
    const InterV__controllerB__rendezVous *c_interaction_v __attribute__((unused)) = static_cast<const InterV__controllerB__rendezVous *>(&interactionValue);
    const Inter__controllerB__rendezVous *c_interaction __attribute__((unused)) = &(c_interaction_v->mInteraction);


    // default to true. May not be the wisest choice.
    return true;
}

const vector<Interaction*>& ConnT__controllerB__rendezVous::interactions() const {
  if (definedInteractions.empty()) {
    definedInteractions.push_back(new Inter__controllerB__rendezVous(*this, true, true));
  }

  // check that the number of defined interactions is correct
  assert(definedInteractions.size() == 1);

  return definedInteractions;
}
